module test_kp1;
	reg clk, intreq;
	wire [14:0] iadr;
	wire [15:0] idata;
	wire [15:0] data_adr;
	wire data_we, intack;
	wire [7:0] data_in, data_out;
	reg [7:0] mem[0:65536];
	initial #0 begin
		clk <= 0;
		intreq <= 0;
	end
//	initial #100 intreq <= 1;
	always #1 begin
		if (~clk) begin
			if (data_we) begin
				mem[data_adr] <= data_out;
			end
			if (intack) intreq <= 0;
		end
		clk <= ~clk;
	end
	assign data_in = mem[data_adr];
	initial #1000000 $finish;
	kp1 kp1(.clk(clk), .inst_adr(iadr), .inst(idata), 
		.intreq(intreq), .intack(intack),
		.data_adr(data_adr), .data_in(data_in), .data_out(data_out), .data_we(data_we));
	rom rom(.clk(clk), .adr(iadr[9:0]), .data(idata));
endmodule

module RAMB16_S1_S9(CLKA, WEA, ENA, SSRA, ADDRA, DIA, DOA,
					CLKB, WEB, ENB, SSRB, ADDRB, DIB, DIPB, DOB, DOPB);
	input CLKA, WEA, ENA, SSRA, CLKB, WEB, ENB, SSRB;
	input [13:0] ADDRA;
	input [10:0] ADDRB;
	input DIA;
	input [7:0] DIB;
	input DIPB;
	output DOA;
	output [7:0] DOB;
	output DOPB;
	reg [13:0] addra1;
	reg [10:0] addrb1;
	reg d[0:16383];
	reg p[0:2047];
	always @(posedge CLKA) begin
		if (WEA) begin
			d[ADDRA] <= DIA;
		end
		addra1 <= ADDRA;
	end
	assign DOA = d[addra1];
	always @(posedge CLKB) begin
		if (WEB) begin
			d[{ ADDRB, 3'b000 }] <= DIB[0];
			d[{ ADDRB, 3'b001 }] <= DIB[1];
			d[{ ADDRB, 3'b010 }] <= DIB[2];
			d[{ ADDRB, 3'b011 }] <= DIB[3];
			d[{ ADDRB, 3'b100 }] <= DIB[4];
			d[{ ADDRB, 3'b101 }] <= DIB[5];
			d[{ ADDRB, 3'b110 }] <= DIB[6];
			d[{ ADDRB, 3'b111 }] <= DIB[7];
			p[ADDRB] <= DIPB;
		end
		addrb1 <= ADDRB;
	end
	assign DOB[0] = d[{ addrb1, 3'b000 }];
	assign DOB[1] = d[{ addrb1, 3'b001 }];
	assign DOB[2] = d[{ addrb1, 3'b010 }];
	assign DOB[3] = d[{ addrb1, 3'b011 }];
	assign DOB[4] = d[{ addrb1, 3'b100 }];
	assign DOB[5] = d[{ addrb1, 3'b101 }];
	assign DOB[6] = d[{ addrb1, 3'b110 }];
	assign DOB[7] = d[{ addrb1, 3'b111 }];
	assign DOPB = p[addrb1];
endmodule

